// July 26th, 2020
// not for sale, rent, auction, nor lease
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Define the Variables to use.....                                 |
//+------------------------------------------------------------------+
extern string             note1                 = "Fibonacci colors";
extern bool               DisplayUpperFibo      = true;
extern color              UpperFiboColor        = clrDarkOliveGreen;
extern ENUM_LINE_STYLE    UpperFiboStyle        = STYLE_DASH;
extern int                UpperFiboWidth        = 1;
extern string             note2                 = "------------------------------";
extern bool               DisplayMainFibo       = true;
extern color              MainFiboColor         = clrOlive;
extern ENUM_LINE_STYLE    MainFiboStyle         = STYLE_DASHDOT;
extern int                MainFiboWidth         = 1;
extern string             note3                 = "------------------------------";
extern bool               DisplayLowerFibo      = true;
extern color              LowerFiboColor        = clrCrimson;
extern ENUM_LINE_STYLE    LowerFiboStyle        = STYLE_DASHDOTDOT;
extern int                LowerFiboWidth        = 1;
extern uint               WeeklyShift           = 1;
//template code start1
extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "FiboW";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 9;                             //btn__font size
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 100;                                     //btn__x
extern int                button_y              = 25;                                     //btn__y
extern int                btn_Width             = 80;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             UniqueButtonID        = "SpudFiboWeekly2022";                               
extern string             button_note2          = "------------------------------";
bool                      show_data             = true;
string buttonId, IndicatorName, IndicatorObjPrefix;
//template code end1
double HiPrice, LoPrice, Range;
datetime StartTime;
//+------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
      name = target + " #" + IntegerToString(try++);
   return name;
}
//+------------------------------------------------------------------+
int OnInit()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + UniqueButtonID;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);
// put init() here
  
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate    (ChartID(),buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), buttonId);

//put deinit() here
      ObjectDelete("FiboUpWeekly");
      ObjectDelete("FiboDownWeekly");
      ObjectDelete("FiboInWeekly");

	return(0);
}
//+------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------+
int DrawFibo()
{
	if(DisplayUpperFibo)
	{
      int banzai	= iBarShift(NULL,PERIOD_W1,Time[0]) + WeeklyShift;	
      HiPrice		= iHigh(NULL,PERIOD_W1,banzai);
	   StartTime	= iTime(NULL,PERIOD_W1,banzai);
	if(ObjectFind("FiboUpWeekly") == -1)
		ObjectCreate("FiboUpWeekly",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("FiboUpWeekly",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboUpWeekly",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboUpWeekly",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("FiboUpWeekly",OBJPROP_PRICE2,HiPrice);
   }
   ObjectSet("FiboUpWeekly",OBJPROP_LEVELSTYLE,UpperFiboStyle);
   ObjectSet("FiboUpWeekly",OBJPROP_LEVELWIDTH,UpperFiboWidth);
   ObjectSet("FiboUpWeekly",OBJPROP_LEVELCOLOR,UpperFiboColor);
   ObjectSet("FiboUpWeekly",OBJPROP_FIBOLEVELS,15);
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+0,0.0);	   
	if (!DisplayMainFibo)
       ObjectSetFiboDescription("FiboUpWeekly",0,"(100.0%) -  %$ "); 
   else    
       ObjectSetFiboDescription("FiboUpWeekly",0,""); 

   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+1,0.236);  	ObjectSetFiboDescription("FiboUpWeekly",1,"(123.6%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+2,0.382); 	ObjectSetFiboDescription("FiboUpWeekly",2,"(138.2%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+3,0.500); 	ObjectSetFiboDescription("FiboUpWeekly",3,"(150.0%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+4,0.618); 	ObjectSetFiboDescription("FiboUpWeekly",4,"(161.8%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+5,0.764); 	ObjectSetFiboDescription("FiboUpWeekly",5,"(176.4%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+6,1.000); 	ObjectSetFiboDescription("FiboUpWeekly",6,"(200.0%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+7,1.236);    ObjectSetFiboDescription("FiboUpWeekly",7,"(223.6%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+8,1.500);    ObjectSetFiboDescription("FiboUpWeekly",8,"(250.0%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+9,1.618);	   ObjectSetFiboDescription("FiboUpWeekly",9,"(261.8%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+10,2.000);	ObjectSetFiboDescription("FiboUpWeekly",10,"(300.0%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+11,2.500);	ObjectSetFiboDescription("FiboUpWeekly",11,"(350.0%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+12,3.000);	ObjectSetFiboDescription("FiboUpWeekly",12,"(400.0%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+13,3.500);	ObjectSetFiboDescription("FiboUpWeekly",13,"(450.0%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_FIRSTLEVEL+14,4.000);	ObjectSetFiboDescription("FiboUpWeekly",14,"(500.0%) -  %$  "); 
   ObjectSet("FiboUpWeekly",OBJPROP_RAY,true);
   ObjectSet("FiboUpWeekly",OBJPROP_BACK,true);
}
   else
	   ObjectDelete("FiboUpWeekly");
//~~~~~~~~~~~~~~~
	if(DisplayLowerFibo)
	{
	   banzai	= iBarShift(NULL,PERIOD_W1,Time[0]) + 1;	// yesterday
	   LoPrice		= iLow (NULL,PERIOD_W1,banzai);
	   StartTime	= iTime(NULL,PERIOD_W1,banzai);
	if(ObjectFind("FiboDownWeekly") == -1)
		ObjectCreate("FiboDownWeekly",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("FiboDownWeekly",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboDownWeekly",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboDownWeekly",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("FiboDownWeekly",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("FiboDownWeekly",OBJPROP_LEVELSTYLE,LowerFiboStyle);
   ObjectSet("FiboDownWeekly",OBJPROP_LEVELWIDTH,LowerFiboWidth);
   ObjectSet("FiboDownWeekly",OBJPROP_LEVELCOLOR,LowerFiboColor);      
   ObjectSet("FiboDownWeekly",OBJPROP_FIBOLEVELS,19);
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+0,0.0);	   
	if (!DisplayMainFibo)
       ObjectSetFiboDescription("FiboDownWeekly",0,"(0.0%) -  %$ "); 
   else
       ObjectSetFiboDescription("FiboDownWeekly",0,""); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+1,0.236); 	ObjectSetFiboDescription("FiboDownWeekly",1,"(-23.6%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+2,0.382); 	ObjectSetFiboDescription("FiboDownWeekly",2,"(-38.2%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+3,0.500); 	ObjectSetFiboDescription("FiboDownWeekly",3,"(-50.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+4,0.618); 	ObjectSetFiboDescription("FiboDownWeekly",4,"(-61.8%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+5,0.764); 	ObjectSetFiboDescription("FiboDownWeekly",5,"(-76.4%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+6,1.000); 	ObjectSetFiboDescription("FiboDownWeekly",6,"(-100.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+7,1.236); 	ObjectSetFiboDescription("FiboDownWeekly",7,"(-123.6%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+8,1.382);	ObjectSetFiboDescription("FiboDownWeekly",8,"(-138.2%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+9,1.500); 	ObjectSetFiboDescription("FiboDownWeekly",9,"(-150.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+10,1.618);	ObjectSetFiboDescription("FiboDownWeekly",10,"(-161.8%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+11,1.764);	ObjectSetFiboDescription("FiboDownWeekly",11,"(-176.4%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+12,2.000);	ObjectSetFiboDescription("FiboDownWeekly",12,"(-200.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+13,2.500);	ObjectSetFiboDescription("FiboDownWeekly",13,"(-250.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+14,3.000);	ObjectSetFiboDescription("FiboDownWeekly",14,"(-300.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+15,3.500);	ObjectSetFiboDescription("FiboDownWeekly",15,"(-350.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+16,4.000);	ObjectSetFiboDescription("FiboDownWeekly",16,"(-400.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+17,4.500);	ObjectSetFiboDescription("FiboDownWeekly",17,"(-450.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_FIRSTLEVEL+18,5.000);	ObjectSetFiboDescription("FiboDownWeekly",18,"(-500.0%) -  %$  "); 
   ObjectSet("FiboDownWeekly",OBJPROP_RAY,true);
   ObjectSet("FiboDownWeekly",OBJPROP_BACK,true);
}
   else
	   ObjectDelete("FiboDownWeekly");
//~~~~~~~~~~~
	if(DisplayMainFibo)
	{
	   banzai	= iBarShift(NULL,PERIOD_W1,Time[0]) + 1;	// yesterday
	   HiPrice		= iHigh(NULL,PERIOD_W1,banzai);
	   LoPrice		= iLow (NULL,PERIOD_W1,banzai);
	   StartTime	= iTime(NULL,PERIOD_W1,banzai);
	
		if(ObjectFind("FiboInWeekly") == -1)
			ObjectCreate("FiboInWeekly",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_W1*60,LoPrice);
		else
		{
			ObjectSet("FiboInWeekly",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboInWeekly",OBJPROP_TIME1, StartTime+PERIOD_W1*60);
			ObjectSet("FiboInWeekly",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboInWeekly",OBJPROP_PRICE2,LoPrice);
		}
      ObjectSet("FiboInWeekly",OBJPROP_LEVELSTYLE,MainFiboStyle);
      ObjectSet("FiboInWeekly",OBJPROP_LEVELWIDTH,MainFiboWidth);
   	ObjectSet("FiboInWeekly",OBJPROP_LEVELCOLOR,MainFiboColor); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIBOLEVELS,7);
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboInWeekly",0,"Last Week LOW (0.0) -  %$  "); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboInWeekly",1,"Week (23.6) -  %$  "); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboInWeekly",2,"Week (38.2) -  %$  "); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboInWeekly",3,"Week (50.0) -  %$  "); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboInWeekly",4,"Week (61.8) -  %$  "); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboInWeekly",5,"Week (76.4) -  %$  "); 
   	ObjectSet("FiboInWeekly",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboInWeekly",6,"Last Week HIGH (100.0) -  %$  "); 
   	ObjectSet("FiboInWeekly",OBJPROP_RAY,true);
   	ObjectSet("FiboInWeekly",OBJPROP_BACK,true);
   }
   else
	   ObjectDelete("FiboInWeekly");
	return (0);
}
//+------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
	   int banzai	= iBarShift(NULL,PERIOD_W1,Time[0]) + 1;	// yesterday
	   HiPrice		= iHigh(NULL,PERIOD_W1,banzai);
	   LoPrice		= iLow (NULL,PERIOD_W1,banzai);
	   StartTime	= iTime(NULL,PERIOD_W1,banzai);

	   if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	   {//Add fridays high and low
		   HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_W1,banzai+1));
		   LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_W1,banzai+1));
	   } //	   if(TimeDayOfWeek(StartTime)==0/*Sunday*/)

	   Range = HiPrice-LoPrice;   

      if (show_data)
      {
        ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
        DrawFibo();
      }
      else
      {
        ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
        ObjectDelete("FiboUpWeekly");
        ObjectDelete("FiboDownWeekly");
        ObjectDelete("FiboInWeekly");
      }
   return(0);
}
//+------------------------------------------------------------------+
